<?php
/*

Copyright 2017 MagicToolbox (email : support@magictoolbox.com)

*/

$error_message = false;
$update_plugin = true;

function WPEcommerce_MagicZoom_activate () {

    set_transient( 'WPEcommerce_MagicZoom_welcome_license_activation_redirect', true, 30 );

    if(!function_exists('file_put_contents')) {
        function file_put_contents($filename, $data) {
            $fp = fopen($filename, 'w+');
            if ($fp) {
                fwrite($fp, $data);
                fclose($fp);
            }
        }
    }

    /* === onlyForMod start: woocommerce */

    //fix url's in css files
    $fileContents = file_get_contents(dirname(__FILE__) . '/core/magiczoom.css');
    $cssPath = preg_replace('/https?:\/\/[^\/]*/is', '', get_option("siteurl"));

    $cssPath .= '/wp-content/'.preg_replace('/^.*?\/(plugins\/.*?)$/is', '$1', str_replace("\\","/",dirname(__FILE__))).'/core';

    $pattern = '#url\(\s*(\'|")?(?!data:|mhtml:|http(?:s)?:|/)([^\)\s\'"]+?)(?(1)\1)\s*\)#is';
    $replace = 'url($1'.$cssPath.'/$2$1)';

    $fixedFileContents = preg_replace($pattern, $replace, $fileContents);
    if($fixedFileContents != $fileContents) {
        file_put_contents(dirname(__FILE__) . '/core/magiczoom.css', $fixedFileContents);
    }

    magictoolbox_WPEcommerce_MagicZoom_create_db();

    magictoolbox_WPEcommerce_MagicZoom_init();

    WPEcommerce_MagicZoom_send_stat('install');
}

function WPEcommerce_MagicZoom_deactivate () {}

function WPEcommerce_MagicZoom_uninstall() {

    magictoolbox_WPEcommerce_MagicZoom_delete_row_from_db('WPEcommerce_MagicZoom_magicscroll');
    magictoolbox_WPEcommerce_MagicZoom_delete_row_from_db();

    if (magictoolbox_WPEcommerce_MagicZoom_is_empty_db() && !count(WPEcommerce_MagicZoom_get_active_modules())) {
        magictoolbox_WPEcommerce_MagicZoom_remove_db();
    }

    delete_option("WPEcommerceMagicZoomCoreSettings");
    WPEcommerce_MagicZoom_send_stat('uninstall');
}

function WPEcommerce_MagicZoom_get_active_modules() {
    $name = explode('/', plugin_basename( __FILE__ ));
    $name = $name[0];
    $mtb_ap = array();

    foreach (get_option('active_plugins') as $value) {
        $name2 = explode('/', $value);
        $name2 = $name2[0];

        if ($name2 != $name && preg_match('/magiczoom|magiczoomplus|magic360|magicslideshow|magicscroll|magicthumb/', $value)) {
            $mtb_ap[] = $value;
        }
    }

    return $mtb_ap;
}

function WPEcommerce_MagicZoom_send_stat($action = '') {

    //NOTE: don't send from working copy
    if('working' == 'v.6.9.4' || 'working' == 'v5.3.7') {
        return;
    }

    $hostname = 'www.magictoolbox.com';

    $url = preg_replace('/^https?:\/\//is', '', get_option("siteurl"));
    $url = urlencode(urldecode($url));

    $platformVersion = defined('WPSC_PRESENTABLE_VERSION') ? WPSC_PRESENTABLE_VERSION : '';

    $path = "api/stat/?action={$action}&tool_name=magiczoom&license=trial&tool_version=v5.3.7&module_version=v.6.9.4&platform_name=wpecommerce&platform_version={$platformVersion}&url={$url}";
    $handle = @fsockopen('ssl://' . $hostname, 443, $errno, $errstr, 30);
    if($handle) {
        $headers  = "GET /{$path} HTTP/1.1\r\n";
        $headers .= "Host: {$hostname}\r\n";
        $headers .= "Connection: Close\r\n\r\n";
        fwrite($handle, $headers);
        fclose($handle);
    }

}





function showMessage_WPEcommerce_MagicZoom($message, $errormsg = false) {
    if ($errormsg) {
        echo '<div id="message" class="error">';
    } else {
        echo '<div id="message" class="updated fade">';
    }
    echo "<p><strong>$message</strong></p></div>";
}


function showAdminMessages_WPEcommerce_MagicZoom(){
    global $error_message;
    if (current_user_can('edit_posts')) {
       showMessage_WPEcommerce_MagicZoom($error_message,true);
    }
}

function WPEcommerce_MagicZoom_LoadScroll($tool) {

    $tool->params->setProfile('product');

    if($tool->params->checkValue('magicscroll', 'yes') && $tool->type == 'standard') {
        require_once(dirname(__FILE__) . '/core/magicscroll.module.core.class.php');
        $scroll = new MagicScrollModuleCoreClass(false);
        $GLOBALS["magictoolbox"]["scroll"] = & $tool;
        //NOTE: load params in a separate profile, in order not to overwrite the options of MagicScroll module
        $scroll->params->appendParams($tool->params->getParams('product'), 'product-magicscroll-options');
        if($tool->params->checkValue('template', 'classic')) {
            $scroll->params->setValue('orientation', 'horizontal', 'product-magicscroll-options');
        }
        if($tool->params->checkValue('template', 'selectors-left')) {
            $scroll->params->setValue('orientation', 'vertical', 'product-magicscroll-options');
        }
        if($tool->params->checkValue('template', array('left', 'right'), 'product')) {
            $scroll->params->setValue('orientation', 'vertical', 'product-magicscroll-options');
        }
        if($tool->params->checkValue('template', array('top', 'bottom'), 'product')) {
            $scroll->params->setValue('orientation', 'horizontal', 'product-magicscroll-options');
        }
        return $scroll;
    }

    return false;
}

function plugin_get_version_WPEcommerce_MagicZoom() {
    $plugin_data = get_plugin_data(dirname(plugin_dir_path(__FILE__)).'/mod_wpecommerce_magiczoom.php');
    $plugin_version = $plugin_data['Version'];
    return $plugin_version;
}

function update_plugin_message_WPEcommerce_MagicZoom() {
    $ver = json_decode(@file_get_contents('http://www.magictoolbox.com/api/platform/wordpress/version/'));
    if (empty($ver)) return false;
    $ver = str_replace('v','',$ver->version);
    $oldVer = plugin_get_version_WPEcommerce_MagicZoom();
    if (version_compare($oldVer, $ver, '<')) {
        echo '<div id="message" class="updated fade">
                  <p>New version available! We recommend that you download the <a href="'.WPEcommerceMagicZoom_url('http://magictoolbox.com/magiczoom/modules/wpecommerce/',' plugins page update link ').'">latest version</a> of Magic Zoom for WPEcommerce . </p>
              </div>';
    }
}

function get_tool_version_WPEcommerce_MagicZoom($tool=null) {
    global $wp_filesystem;

    if (!$tool) {
        $tool = 'magiczoom';
    }

    WP_Filesystem();

    if (empty($wp_filesystem)) {
        require_once (ABSPATH . '/wp-admin/includes/file.php');
        WP_Filesystem();
    }

    $r = $wp_filesystem->get_contents(plugin_dir_path( __FILE__ ).'core/'.$tool.'.js');

    if (!preg_match('/demo/is',$r)) {
        $version = 'commercial';
    } else {
        $version = 'trial';
    }
    return $version;
}


function  magictoolbox_WPEcommerce_MagicZoom_init() {

    add_action( 'admin_init', 'WPEcommerceMagicZoom_welcome_license_do_redirect' );

    global $error_message;


    add_action("admin_menu", "magictoolbox_WPEcommerce_MagicZoom_config_page_menu");
    add_action('admin_enqueue_scripts', 'WPEcommerce_MagicZoom_load_admin_scripts');
    add_action('wp_enqueue_scripts', 'WPEcommerce_MagicZoom_load_frontend_scripts');

    //add_filter('filesystem_method', create_function('$a', 'return "direct";' ));
    add_filter('filesystem_method', function($a) { return "direct"; });

    add_filter("the_content", "magictoolbox_WPEcommerce_MagicZoom_create", 13);

    require_once(dirname(__FILE__)."/core/autoupdate.php");
    require_once(dirname(__FILE__)."/core/view/import_export/export.php");
    add_action('wp_ajax_WPEcommerce_MagicZoom_import', 'WPEcommerce_MagicZoom_import');
    add_action('wp_ajax_WPEcommerce_MagicZoom_export', 'WPEcommerce_MagicZoom_export');


    add_action('wp_ajax_magictoolbox_WPEcommerce_MagicZoom_set_license', 'magictoolbox_WPEcommerce_MagicZoom_set_license');



    
    
    
    add_filter( 'plugin_action_links', 'magictoolbox_WPEcommerce_MagicZoom_links', 10, 2 );
    add_filter( 'plugin_row_meta', 'magictoolbox_WPEcommerce_MagicZoom_plugin_row_meta' , 10, 2 );

    if ($error_message) add_action('admin_notices', 'showAdminMessages_WPEcommerce_MagicZoom');

    if(!isset($GLOBALS['magictoolbox']['WPEcommerceMagicZoom'])) {
        require_once(dirname(__FILE__) . '/core/magiczoom.module.core.class.php');
        $coreClassName = "MagicZoomModuleCoreClass";
        $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'] = new $coreClassName;
        $coreClass = &$GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];
    }
    $coreClass = &$GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];
    /* get current settings from db */
    $settings = get_option("WPEcommerceMagicZoomCoreSettings");
    if($settings !== false && is_array($settings) && isset($settings['default']) && !isset($_GET['reset_settings'])) {
        foreach (WPEcommerceMagicZoom_getParamsProfiles() as $profile => $name) {
        if (isset($settings[$profile])) {
        $coreClass->params->appendParams($settings[$profile],$profile);
        }
    }
    } else { //set defaults
        $allParams = array();
        $defaults = $coreClass->params->getParams('default');
        $map = WPEcommerceMagicZoom_getParamsMap();

    foreach (WPEcommerceMagicZoom_getParamsProfiles() as $profile => $name) {
        $params = array();
        foreach ($defaults as $id => $param) {;
                if (isset($map[$profile][$param['group']]) && is_array($map[$profile][$param['group']]) && in_array($id,$map[$profile][$param['group']])) { //set defaults only according to mapping
                    $params[$id] = $param;
                }
            }
            $coreClass->params->setParams($params,$profile);

        if ($profile == 'product') {
        $coreClass->params->setValue('thumb-max-width',get_option('single_view_image_width'),$profile);
        $coreClass->params->setValue('thumb-max-height',get_option('single_view_image_height'),$profile);
        }
        $allParams[$profile] = $coreClass->params->getParams($profile);
    }

    $allParams['product']['page-status']['default'] = 'yes'; //TODO?

    delete_option("WPEcommerceMagicZoomCoreSettings");
        add_option("WPEcommerceMagicZoomCoreSettings", $allParams,'','no');
    }

    add_action( 'upgrader_process_complete', 'WPEcommerce_MagicZoom_get_packed_js', 10, 2 );
    
}

function WPEcommerce_MagicZoom_init_wp_filesystem($form_url) {
    global $wp_filesystem;
    $creds = request_filesystem_credentials($form_url, '', false, plugin_dir_path( __FILE__ ), false);

    if (!WP_Filesystem($creds)) {
        request_filesystem_credentials($form_url, '', true, plugin_dir_path( __FILE__ ), false);
        return false;
    }
    return true;
}

function WPEcommerce_MagicZoom_write_file ($url, $content) {
    global $wp_filesystem;
    // if (empty($wp_filesystem)) {
    //     require_once (ABSPATH . '/wp-admin/includes/file.php');
    // }
    WPEcommerce_MagicZoom_init_wp_filesystem($url);

    $result = $wp_filesystem->put_contents($url, $content, FS_CHMOD_FILE );

    return $result ? null : "Failed to write to file";
}

function WPEcommerce_MagicZoom_rewrite ($option, $tool) {
    $response = get_option($option);
    $result = WPEcommerce_MagicZoom_write_file(plugin_dir_path(__FILE__).'core/'.$tool.'.js', $response);
    //delete_option($option);
    return $result;
}

function WPEcommerce_MagicZoom_get_packed_js ($upgrader_object, $options) {
    if ('update' == $options['action'] && 'plugin' == $options['type']) {
        foreach ($options['plugins'] as $pl) {
            $_plugin = explode("/", $pl);
            $_plugin = $_plugin[count($_plugin) - 1];
            if ('mod_wpecommerce_magiczoom.php' === $_plugin) {
                $key = magictoolbox_WPEcommerce_MagicZoom_get_data_from_db();
                if (!$key) {
                    $result = WPEcommerce_MagicZoom_rewrite("WPEcommerce_MagicZoom_backup", 'magiczoom');
                }
                $result2 = WPEcommerce_MagicZoom_rewrite("WPEcommerce_MagicZoom_magicscroll_backup", 'magicscroll');
                break;
            }
        }
    }
}

function WPEcommerce_MagicZoom_load_frontend_scripts () {
    $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];

    $tool_lower = 'magiczoom';
    switch ($tool_lower) {
        case 'magicthumb':      $priority = '10'; break;
        case 'magic360':        $priority = '11'; break;
        case 'magiczoom':       $priority = '12'; break;
        case 'magiczoomplus':   $priority = '13'; break;
        case 'magicscroll':     $priority = '14'; break;
        case 'magicslideshow':  $priority = '15'; break;
        default :               $priority = '11'; break;
    }

    wp_register_style( 'magictoolbox_magiczoom_style', plugin_dir_url( __FILE__ ).'core/magiczoom.css', array(), false, 'all');
    wp_register_style( 'magictoolbox_magiczoom_module_style', plugin_dir_url( __FILE__ ).'core/magiczoom.module.css', array(), false, 'all');
    wp_register_script( 'magictoolbox_magiczoom_script', plugin_dir_url( __FILE__ ).'core/magiczoom.js', array(), false, true);
    add_action("wp_footer", "magictoolbox_WPEcommerce_MagicZoom_add_src_to_footer", $priority);
    add_action("wp_footer", "magictoolbox_WPEcommerce_MagicZoom_add_options_script", 10001);
}

function WPEcommerce_MagicZoom_load_admin_scripts () {
    wp_enqueue_script( 'jquery' ,includes_url('/js/jquery/jquery.js'));
    wp_enqueue_script( 'jquery-ui-core', includes_url('/js/jquery/ui/core.js') );
    wp_enqueue_script( 'jquery-ui-tabs', includes_url('/js/jquery/ui/tabs.js') );

    $ownPage = false;
    if (array_key_exists('page', $_GET)) {
        $ownPage =  "WPEcommerceMagicZoom-config-page" ==  $_GET["page"]        ||
                    "WPEcommerceMagicZoom-shortcodes-page" ==  $_GET["page"]    ||
                    "WPEcommerceMagicZoom-import-export-page" ==  $_GET["page"] ||
                    "WPEcommerceMagicZoom-license-page" ==  $_GET["page"];
    }

    if (is_admin()) {
        wp_register_script( 'wpecommerce_MagicZoom_admin_adminpage_script', plugin_dir_url( __FILE__ ).'core/wpecommerce_MagicZoom_adminpage.js', array('jquery', 'jquery-ui-core', 'jquery-ui-tabs'), null );
        wp_enqueue_style( 'magictoolbox_wpecommerce_MagicZoom_admin_menu_style', plugin_dir_url( __FILE__ ).'core/admin_menu.css', array(), null );
        if ($ownPage) {
            wp_enqueue_style( 'magictoolbox_wpecommerce_MagicZoom_admin_page_style', plugin_dir_url( __FILE__ ).'core/admin.css', array(), null );
        }

        if ($ownPage) {
            wp_enqueue_style( 'WPEcommerce_MagicZoom_admin_import_export_style', plugin_dir_url( __FILE__ ).'core/view/import_export/wpecommerce_MagicZoom_import_export.css', array(), null );
            wp_enqueue_style( 'WPEcommerce_MagicZoom_admin_license_style', plugin_dir_url( __FILE__ ).'core/view/license/wpecommerce_MagicZoom_license.css', array(), null );
        }
        wp_register_script( 'WPEcommerce_MagicZoom_admin_import_export_script', plugin_dir_url( __FILE__ ).'core/view/import_export/wpecommerce_MagicZoom_import_export.js', array('jquery'), null );
        wp_register_script( 'WPEcommerce_MagicZoom_admin_license_script', plugin_dir_url( __FILE__ ).'core/view/license/wpecommerce_MagicZoom_license.js', array('jquery'), null );
    }
}


/**
  * Show row meta on the plugin screen.
  *
  * @param  mixed $links Plugin Row Meta
  * @param  mixed $file  Plugin Base file
  * @return array
  */

function magictoolbox_WPEcommerce_MagicZoom_plugin_row_meta( $links, $file ) {

    if (strpos(plugin_dir_path(__FILE__),plugin_dir_path($file))) {
        $row_meta = array($links[0],$links[1]);
        $row_meta['Settings'] = '<a href="admin.php?page=WPEcommerceMagicZoom-config-page">'.__('Settings').'</a>';
        $row_meta['Support'] =  '<a target="_blank" href="'.WPEcommerceMagicZoom_url('https://www.magictoolbox.com/contact/','plugins page support link').'">Support</a>';
        $row_meta['Buy'] = '<a target="_blank" href="'.WPEcommerceMagicZoom_url('https://www.magictoolbox.com/buy/magiczoom/','plugins page buy link').'">Buy</a>';
        $row_meta['More cool plugins'] = '<a target="_blank" href="'.WPEcommerceMagicZoom_url('https://www.magictoolbox.com/wpecommerce/','plugins page more cool plugins link').'">More cool plugins</a>';

        return $row_meta;
    }

    return (array) $links;
}

function WPEcommerceMagicZoom_config_page() {
    include 'core/view/settings/wpecommerce_MagicZoom_settings.php';
}

function WPEcommerce_MagicZoom_add_admin_src_to_menu_page() {
    wp_enqueue_script( 'wpecommerce_MagicZoom_admin_adminpage_script' );

    $arr = array(
        'ajax'   => get_site_url().'/wp-admin/admin-ajax.php',
        'nonce'  => wp_create_nonce('magic-everywhere'),
        'mtburl' => 'https://www.magictoolbox.com/site/order/'
    );

    wp_localize_script( 'wpecommerce_MagicZoom_admin_adminpage_script', 'magictoolbox_WPEcommerce_MagicZoom_admin_modal_object', $arr);
}

function WPEcommerce_MagicZoom_import() {
    if(!(is_array($_POST) && defined('DOING_AJAX') && DOING_AJAX)){
        return;
    }

    $nonce = $_POST['nonce'];
    $tool = 'wpecommerce_magiczoom';

    if ( !wp_verify_nonce( $nonce, 'magic-everywhere' ) ) {
        return;
    }

    $file = $_FILES['file'];

    $arr = (array) simplexml_load_string(file_get_contents($file["tmp_name"]),'SimpleXMLElement', LIBXML_NOCDATA);

    if (array_key_exists('tool', $arr) && $tool == $arr['tool']) {
        if (array_key_exists('license', $arr) && $arr['license'] != 'trial' && strlen($arr['license']) == 7) {
            magictoolbox_WPEcommerce_MagicZoom_update_db($arr['license']);

            $url = 'https://www.magictoolbox.com/site/order/'.$arr['license'].'/magiczoom.js';
            $response = magictoolbox_WPEcommerce_MagicZoom_get_file($url);
            if($response['status'] == 200) {
                WPEcommerce_MagicZoom_write_file(plugin_dir_path( __FILE__ ).'core/magiczoom.js', $response['content']);
            }
        }
        if (array_key_exists('scrolllicense', $arr) && $arr['scrolllicense'] != 'trial' && strlen($arr['scrolllicense']) == 7) {
            magictoolbox_WPEcommerce_MagicZoom_update_db($arr['scrolllicense'], 'WPEcommerce_MagicZoom_magicscroll');
            $url = 'https://www.magictoolbox.com/site/order/'.$arr['scrolllicense'].'/magicscroll.js';
            $response = magictoolbox_WPEcommerce_MagicZoom_get_file($url);
            if($response['status'] == 200) {
                WPEcommerce_MagicZoom_write_file(plugin_dir_path( __FILE__ ).'core/magicscroll.js', $response['content']);
            }
        }

        if (array_key_exists('core', $arr)) {
            $core = (array) $arr['core'];

            $settings = get_option("WPEcommerceMagicZoomCoreSettings");

            foreach ($core as $profile => $name) {
                $name = (array) $name;
                foreach ($name as $key => $value) {
                    $value = (array) $value;
                    if ('' != $value[0]) {
                        $settings[$profile][$key]['value'] = $value[0];
                    }
                }
            }

            delete_option("WPEcommerceMagicZoomCoreSettings");
            add_option("WPEcommerceMagicZoomCoreSettings", $settings,'','no');
        }

    }
    // exit;
}

function WPEcommerce_MagicZoom_export() {
    if(!(is_array($_POST) && defined('DOING_AJAX') && DOING_AJAX)){
        return;
    }

    $nonce = $_POST['nonce'];
    $value = $_POST['value'];
    $secret_data = null;

    if ( !wp_verify_nonce( $nonce, 'magic-everywhere' ) ) {
        return;
    }

    //WPEcommerce_MagicZoom_wp_export($value, get_option("WPEcommerceMagicZoomCoreSettings"), $secret_data);
    WPEcommerce_MagicZoom_wp_export(get_option("WPEcommerceMagicZoomCoreSettings"), $secret_data, $value);
    exit;
}

function magictoolbox_WPEcommerce_MagicZoom_add_src_to_footer() {
    global $magictoolbox_MagicZoom_page_has_shortcode,
           $magictoolbox_MagicZoom_page_has_tool,
           $magictoolbox_page_has_gallery,
           $magictoolbox_MagicZoom_page_added_script,
           $magictoolbox_page_added_gallery_script,
           $magictoolbox_page_has_shortcode_gallery,
           $magictoolbox_page_added_shortcode_gallery_script;

    if (!$magictoolbox_MagicZoom_page_has_tool) {
        $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];

        if ($plugin->params->checkValue('include-headers','yes') || isset($GLOBALS['custom_template_headers'])) {
            $magictoolbox_MagicZoom_page_has_tool = true; // add footers for all pages
            //if (isset($GLOBALS['custom_template_headers'])) unset($GLOBALS['custom_template_headers']); //prevent render on non-product pages
            $magictoolbox_page_has_gallery = true;
        }
    }

    if (!$magictoolbox_MagicZoom_page_added_script) {
        $magictoolbox_MagicZoom_page_added_script = true;

        if ($magictoolbox_MagicZoom_page_has_shortcode || $magictoolbox_MagicZoom_page_has_tool) {
            wp_enqueue_style('magictoolbox_magiczoom_style');
            wp_enqueue_style('magictoolbox_magiczoom_module_style');
            wp_enqueue_script('magictoolbox_magiczoom_script');
        }


        if ($magictoolbox_MagicZoom_page_has_tool) {
            // wp_enqueue_style('magictoolbox_magiczoom_style');
            // wp_enqueue_style('magictoolbox_magiczoom_module_style');
            // wp_enqueue_script('magictoolbox_magiczoom_script');
        }
    }

    if (!$magictoolbox_page_added_gallery_script && $magictoolbox_page_has_gallery) {
        $magictoolbox_page_added_gallery_script = true;
        wp_enqueue_style('magictoolbox_magiczoom_gallery_style');
        wp_enqueue_script('magictoolbox_magiczoom_gallery_script');
    }
}

function magictoolbox_WPEcommerce_MagicZoom_add_options_script () {
    global $magictoolbox_MagicZoom_page_added_options,
            $magictoolbox_MagicZoom_page_has_shortcode,
            $magictoolbox_MagicZoom_page_has_tool;
    $footers = '';

    if (!$magictoolbox_MagicZoom_page_added_options) {
        $magictoolbox_MagicZoom_page_added_options = true;


        if ($magictoolbox_MagicZoom_page_has_shortcode || $magictoolbox_MagicZoom_page_has_tool) {
            $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];
            $footers = $plugin->getOptionsTemplate();


            if (function_exists('plugins_url')) {
                $core_url = plugins_url();
            } else {
                $core_url = get_option("siteurl").'/wp-content/plugins';
            }
            $path = preg_replace('/^.*?\/plugins\/(.*?)$/is', '$1', str_replace("\\","/",dirname(__FILE__)));
            $scroll = WPEcommerce_MagicZoom_LoadScroll($plugin);
            if($scroll) {
                $scroll->params->resetProfile();
                $footers .= $scroll->getHeadersTemplate($core_url."/{$path}/core", null, false);
            }

            global $sTemplateJs;
            if (isset($sTemplateJs) && !empty($sTemplateJs)) {
                $footers .= $sTemplateJs;
            }
        }
        echo $footers;
    }
}

function magictoolbox_WPEcommerce_MagicZoom_get_file($url) {
    $result = array( 'content' => '', 'status' => 0);

    if ($url && is_string($url)) {
        $url = trim($url);
        if ('' != $url) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
            $response = curl_exec($ch);
            $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

            $result['content'] = $response;
            $result['status'] = $code;
        }
    }

    return $result;
}

function magictoolbox_WPEcommerce_MagicZoom_set_license() {
    global $wp_filesystem;

    if (empty($wp_filesystem)) {
        require_once (ABSPATH . '/wp-admin/includes/file.php');
    }

    WP_Filesystem();
    // ob_end_clean();

    if(!(is_array($_POST) && defined('DOING_AJAX') && DOING_AJAX)){
        return;
    }

    $nonce = $_POST['nonce'];
    $key = $_POST['key'];
    $extra_param = $_POST['param'];
    $result = '{"error": "error"}';

    if (!$extra_param || 'null' == $extra_param) {
        $extra_param = null;
        $tool_name = 'magiczoom';
    } else {
        $tool_name = $extra_param;
        $extra_param = 'WPEcommerce_MagicZoom_'.$extra_param;
    }

    if ( !wp_verify_nonce( $nonce, 'magic-everywhere' ) ) {
        $result = '{"error": "verification failed"}';
    } else {
        if ($key && '' != $key) {
            $url = 'https://www.magictoolbox.com/site/order/'.$key.'/'.$tool_name.'.js';
            $response = magictoolbox_WPEcommerce_MagicZoom_get_file($url);

            $code = $response['status'];
            $response = $response['content'];

            if($code == 200) {
                $result = WPEcommerce_MagicZoom_write_file(plugin_dir_path( __FILE__ ).'core/'.$tool_name.'.js', $response);
                if (!$result) {
                    magictoolbox_WPEcommerce_MagicZoom_update_db($key, $extra_param);
                    $result = 'null';
                }
                $result = '{"error": '.$result.'}';
            } else if($code == 403) {
                $result = '{"error": "limit"}';
                //Download limit reached
                //Your license has been downloaded 10 times already.
                //If you wish to download your license again, please contact us.
            } else if ($code == 404) {
                $result = '{"error": "license failed"}';
            } else {
                $result = '{"error": "Other errors"}';
            }
        }
    }
    ob_end_clean();
    echo $result;
    wp_die();
}

function magictoolbox_WPEcommerce_MagicZoom_create_db() {
    global $wpdb;

    $table_name = $wpdb->prefix . 'magictoolbox_store';
    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
        $sql = "CREATE TABLE $table_name (
          id int unsigned NOT NULL auto_increment,
          name varchar(50) DEFAULT NULL,
          license varchar(50) DEFAULT NULL,
          UNIQUE KEY id (id));";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
    }
}

function magictoolbox_WPEcommerce_MagicZoom_remove_db() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'magictoolbox_store';

    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
        $wpdb->query("DROP TABLE IF EXISTS ".$table_name);
    }
}

function magictoolbox_WPEcommerce_MagicZoom_update_db($key, $name=null) {
    global $wpdb;
    $result = false;

    if (!$name || !is_string($name)) {
        $name = 'WPEcommerce_MagicZoom';
    }

    if ($key && is_string($key)) {
        $table_name = $wpdb->prefix . 'magictoolbox_store';

        $data = $wpdb->get_results("SELECT * FROM ".$table_name." WHERE name = '" . $name . "'");

        if ($data && count($data) > 0) {
            $result = $wpdb->update($table_name, array('license' => $key), array('name' => $name), array( '%s' ), array( '%s' ));
            $result = !!$result;
        } else {
            $result = $wpdb->insert($table_name, array('name' => $name, 'license' => $key));
        }
    }

    return $result;
}

function magictoolbox_WPEcommerce_MagicZoom_delete_row_from_db($name=null) {
    global $wpdb;

    if (!$name || !is_string($name)) {
        $name = 'WPEcommerce_MagicZoom';
    }

    $table_name = $wpdb->prefix . 'magictoolbox_store';
    if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
        return $wpdb->delete( $table_name, array( 'name' => $name ) );
    } else {
        return false;
    }
}

function magictoolbox_WPEcommerce_MagicZoom_is_empty_db() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'magictoolbox_store';
    if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
        $result = $wpdb->get_results("SELECT * FROM ".$table_name);
        return !(count($result) > 0);
    } else {
        return false;
    }
}

function magictoolbox_WPEcommerce_MagicZoom_get_data_from_db($name=null) {
    global $wpdb;
    
    if (!$name || !is_string($name)) {
        $name = 'WPEcommerce_MagicZoom';
    }
    
    if (isset($GLOBALS['WPEcommerce_MagicZoom_get_data_from_db'][$name])) {
        return $GLOBALS['WPEcommerce_MagicZoom_get_data_from_db'][$name];
    }

    $table_name = $wpdb->prefix . 'magictoolbox_store';
    $result = $wpdb->get_results("SELECT * FROM ".$table_name." WHERE name = '".$name."'");
    
    if ($result && count($result) > 0) {
        $GLOBALS['WPEcommerce_MagicZoom_get_data_from_db'][$name] = $result[0];
        return $result[0];
    } else {
        $GLOBALS['WPEcommerce_MagicZoom_get_data_from_db'][$name] = false;
        return false;
    }
}

function magictoolbox_WPEcommerce_MagicZoom_links( $links, $file ) {
    $fileName = 'mod_wpecommerce_magiczoom_trial/mod_wpecommerce_magiczoom.php';
    
    $fileName = preg_replace('/\_trial\//', '/', $fileName);
    $fileName = preg_replace('/\_commercial\//', '/', $fileName);
    
    if ($file == $fileName) {
        $settings_link = '<a href="admin.php?page=WPEcommerceMagicZoom-config-page">'.__('Settings').'</a>';
        array_unshift( $links, $settings_link );
    }
    return $links;
}

function magictoolbox_WPEcommerce_MagicZoom_config_page_menu() {
    if(function_exists("add_menu_page")) {
        $page = add_menu_page(__("Magic Zoom for WP e-Commerce"), __("Magic Zoom for WP e-Commerce"), "edit_posts", "WPEcommerceMagicZoom-config-page", "WPEcommerceMagicZoom_config_page", plugin_dir_url( __FILE__ )."core/admin_graphics/icon.svg");
        add_submenu_page( "WPEcommerceMagicZoom-config-page", 'Settings', 'Settings', 'edit_posts', "WPEcommerceMagicZoom-config-page" );
        add_action('admin_print_scripts-' . $page, 'WPEcommerce_MagicZoom_add_admin_src_to_menu_page');
    }

    if(function_exists("add_submenu_page")) {

        $license_page = add_submenu_page("WPEcommerceMagicZoom-config-page", "License", "License", "edit_posts", "WPEcommerceMagicZoom-license-page", "WPEcommerce_MagicZoom_license_page");
        add_action('admin_print_scripts-' . $license_page, 'WPEcommerce_MagicZoom_add_admin_src_to_license_page');
        $import_export_page = add_submenu_page("WPEcommerceMagicZoom-config-page", "Backup / Restore", "Backup / Restore", "edit_posts", "WPEcommerceMagicZoom-import-export-page", "WPEcommerce_MagicZoom_import_export_page");
        add_action('admin_print_scripts-' . $import_export_page, 'WPEcommerce_MagicZoom_add_admin_src_to_import_export_page');

    }
}


function WPEcommerce_MagicZoom_import_export_page() {
    include 'core/view/import_export/wpecommerce_MagicZoom_import_export.php';
}

function WPEcommerce_MagicZoom_add_admin_src_to_import_export_page() {
    wp_enqueue_script( 'WPEcommerce_MagicZoom_admin_import_export_script' );
    wp_localize_script( 'WPEcommerce_MagicZoom_admin_import_export_script', 'magictoolbox_WPEcommerce_MagicZoom_admin_modal_object', array('ajax' =>  get_site_url().'/wp-admin/admin-ajax.php', 'nonce' => wp_create_nonce('magic-everywhere')) );
}

function WPEcommerce_MagicZoom_license_page() {
    include 'core/view/license/wpecommerce_MagicZoom_license.php';
}

function WPEcommerce_MagicZoom_add_admin_src_to_license_page() {
    wp_enqueue_script( 'WPEcommerce_MagicZoom_admin_license_script' );
    wp_localize_script( 'WPEcommerce_MagicZoom_admin_license_script', 'magictoolbox_WPEcommerce_MagicZoom_admin_modal_object', array('ajax' =>  get_site_url().'/wp-admin/admin-ajax.php', 'nonce' => wp_create_nonce('magic-everywhere')) );
}

function magictoolbox_WPEcommerce_MagicZoom_styles() {
    if(!defined('MAGICTOOLBOX_MAGICZOOM_HEADERS_LOADED')) {
        $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];

        
        if (function_exists('plugins_url')) {
            $core_url = plugins_url();
        } else {
            $core_url = get_option("siteurl").'/wp-content/plugins';
        }


        $path = preg_replace('/^.*?\/plugins\/(.*?)$/is', '$1', str_replace("\\","/",dirname(__FILE__)));

        $headers = $plugin->getHeadersTemplate($core_url."/{$path}/core");

            $scroll = WPEcommerce_MagicZoom_LoadScroll($plugin);
            if($scroll) {
                $scroll->params->resetProfile();
                $headers .= $scroll->getHeadersTemplate($core_url."/{$path}/core", null, false);
            }
        echo $headers;
        define('MAGICTOOLBOX_MAGICZOOM_HEADERS_LOADED', true);
    }
}




function  magictoolbox_WPEcommerce_MagicZoom_create($content) {
    global $magictoolbox_MagicZoom_page_has_tool;

    $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];


    /*set watermark options for all profiles START */
    $defaultParams = $plugin->params->getParams('default');
    $wm = array();
    $profiles = $plugin->params->getProfiles();
    foreach ($defaultParams as $id => $values) {
    if (($values['group']) == 'Watermark') {
        $wm[$id] = $values;
    }
    }
    foreach ($profiles as $profile) {
    $plugin->params->appendParams($wm,$profile);
    }
    /*set watermark options for all profiles END */

    $toolPatern = "<a\s+[^>]*class\s*=[^>]*\"MagicZoom[^>]*\"[^>]*>\s*<img[^>]*>\s*<\s*\/\s*a>";


    $pattern = "(?:<a([^>]*class=\"thickbox[^\"]*\"[^>]*)>)[^<]*<img([^>]*)(?:>)(?:[^<]*<\/img>)?(.*?)[^<]*?<\/a>";

    $oldContent = $content;
    $post_id = wpsc_the_product_id();



        $content = preg_replace_callback("/{$pattern}/is","magictoolbox_WPEcommerce_MagicZoom_callback",$content);
        if ($content == $oldContent) return $content;
        $magictoolbox_MagicZoom_page_has_tool = true;


    if (@count($GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS']) > 0) { //if there any additional images present
        $selectors = '<div class="MagicToolboxSelectorsContainer">'.implode($GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS']).'</div>';
        $content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS}',$selectors,$content); // insert selectors under main image

        $contentWithGallery = $content;


        $content = preg_replace ('/<h2[^>]*>Gallery<\/h2><div[^>]*>.*?div>/is','',$content); //cut gallery div v1
        if ($content == $contentWithGallery) {
            $content = preg_replace ('/<div[^>]*?class=[\'\"](wpcart_gallery|single_image_thumb|multi_image_box hide).*?[\'\"][^>]*?>.*?div>/is','',$content); //cut gallery div v2
        }

    }

    /*$content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR}',$GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR'],$content);  //add main image selector to other
    $content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS}','',$content); //if no selectors - remove constant
     onlyForModend  */

    
    if (!$plugin->params->checkValue('template','original') && $plugin->type == 'standard' && isset($GLOBALS['magictoolbox']['MagicZoom']['main'])) {
        // template helper class
        require_once(dirname(__FILE__) . '/core/magictoolbox.templatehelper.class.php');
        MagicToolboxTemplateHelperClass::setPath(dirname(__FILE__).'/core/templates');
        MagicToolboxTemplateHelperClass::setOptions($plugin->params);
        if (!WPEcommerce_MagicZoom_page_check('WPEcommerce')) { //do not render thumbs on category pages
            $thumbs = WPEcommerce_MagicZoom_get_prepared_selectors($post_id);
        } else {
            $thumbs = array();
        }

        if (isset($GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_SELECTORS']) && is_array($GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_SELECTORS'])) {
        $thumbs = array_merge($thumbs,$GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_SELECTORS']);
        }



    if (!isset($GLOBALS['magictoolbox']['prods_info']['product_id']) && isset($post_id)) {
        $GLOBALS['magictoolbox']['prods_info']['product_id'] = $post_id;
    } else if (!isset($GLOBALS['magictoolbox']['prods_info']['product_id']) && !isset($post_id)) {
        $GLOBALS['magictoolbox']['prods_info']['product_id'] = '';
    }
        $scroll = WPEcommerce_MagicZoom_LoadScroll($plugin);

        $mainHTML = $GLOBALS['magictoolbox']['MagicZoom']['main'];
        $magicscrollOptions = '';
        if($plugin->params->checkValue('magicscroll', 'Yes')) {
            $magicscrollOptions = $scroll->params->serialize(false, '', 'product-magicscroll-options');
        }


        $html = MagicToolboxTemplateHelperClass::render(array(
            'main' => $mainHTML,
            'thumbs' => (count($thumbs) >= 1) ? $thumbs : array(),
            'magicscrollOptions' => $magicscrollOptions,
            'pid' => $GLOBALS['magictoolbox']['prods_info']['product_id'],
        ));



        $content = str_replace('MAGICTOOLBOX_PLACEHOLDER', $html, $content);
    } else if ($plugin->params->checkValue('template','original') || $plugin->type != 'standard') {
        if (isset($GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR'])) {
            $content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR}', $GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR'], $content);  //add main image selector to other
        }
        if (isset($GLOBALS['magictoolbox']['MagicZoom'])) {
            $html = $GLOBALS['magictoolbox']['MagicZoom']['main'];
            $content = str_replace('MAGICTOOLBOX_PLACEHOLDER', $html, $content);
        }
    }
    $content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR}','',$content);
    $content = str_replace('{MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS}','',$content); //if no selectors - remove constant
    $content = preg_replace ('/<div[^>]*?class="thumbnails[^"]*?"[^>]*?>.*?div>/is','',$content); // remove selectors div
    $content = preg_replace ('/<div[^>]*?class="woocommerce-product-gallery__image[^"]*?"[^>]*?>.*?div>/is','',$content); // remove selectors div



    if (!$magictoolbox_MagicZoom_page_has_tool) {
        if (preg_match("/{$toolPatern}/is", $content)) {
            $magictoolbox_MagicZoom_page_has_tool = true;
        }
    }

    return $content;
}

function magictoolbox_WPEcommerce_MagicZoom_key_sort($a, $b){
    return strnatcasecmp(basename($a['img']),basename($b['img']));
}




function  magictoolbox_WPEcommerce_MagicZoom_callback($matches) {
    $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];
    $title = "";
    $float = "";
    $cat = WPEcommerce_MagicZoom_page_check('WPEcommerce');
    if ($cat === 'error') return $matches[0];
    if ($cat) $plugin->params->setProfile('category');
    if (!$cat) $plugin->params->setProfile('product');
    $plugin_enabled = true;
    $is_selector = true;
    $is_main = true;
    


    if(!preg_match("/class\s*=\s*[\'\"]\s*(?:[^\"\'\s]*\s)*product_image(?:\s[^\"\'\s]*)*\s*[\'\"]/iUs",$matches[0])) {
        $is_main = false;
    }
    if(!preg_match("/class\s*=\s*[\'\"]\s*(?:[^\"\'\s]*\s)*(thickbox|image_thumb_clickable)(?:\s[^\"\'\s]*)*\s*[\'\"]/iUs",$matches[0])) {
        $is_selector = false;
    }
    if (!$is_selector && !$is_main) {
        $plugin_enabled = false;
    }
    if ($plugin->params->checkValue('page-status','No')) $plugin_enabled = false;
    if (!$plugin_enabled) return $matches[0];


    $alignclass = preg_replace('/^.*?align(left|right|center|none).*$/is', '$1', $matches[2]);
    if($alignclass != $matches[2]) {
        $alignclass = ' align'.$alignclass;
    } else {
        $alignclass='';
        $float = preg_replace('/^.*?float:\s*(left|right|none).*$/is', '$1', $matches[2]);
        if($float == $matches[2]) {
            $float = '';
        } else {
            $float = ' float: ' . $float . ';';
        }
    }
    // get needed attributes
    global $wp_query;
    $alt = preg_replace("/^.*?alt\s*=\s*[\"\'](.*?)[\"\'].*$/is","$1",$matches[2]);
    if (isset($matches[1]) && !empty($matches[1])) { // thecartpress fix
    $img = preg_replace("/^.*?href\s*=\s*[\"\'](.*?)[\"\'].*$/is","$1",$matches[1]);
    $thumb = preg_replace("/^.*?src\s*=\s*[\"\'](.*?)[\"\'].*$/is","$1",$matches[2]);
    } else {
    $thumb = $img = preg_replace("/^.*?href\s*=\s*[\"\'](.*?)[\"\'].*$/is","$1",$matches[2]); // only thecartpress
    }
    
    $title = preg_replace("/^.*?title\s*=\s*[\"\'](.*?)[\"\'].*$/is","$1",$matches[0]);
    if($title == $matches[0]) unset($title);
    
    
    
    
    $id = preg_replace("/^.*?id=\"([^\"]*?(\d+)[^\"]*)\".*$/is","$2",$matches[2]);
    if($cat && $plugin->params->checkValue('link-to-product-page', 'Yes')) {
        $link = wpsc_product_url($id);
    } else {
        $link = false;
    }

    $id = '_Main';




    $aStyles = $matches[1];
    $imgStyles = $matches[2];
    
    $matches[1] = preg_replace("/^(.*?)rel\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    
    $matches[1] = preg_replace("/^(.*?)id\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    $matches[1] = preg_replace("/^(.*?)class\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    $matches[1] = preg_replace("/^(.*?)title\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    $matches[1] = preg_replace("/^(.*?)rev\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    $matches[1] = preg_replace("/^(.*?)href\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[1]);
    // remove src attribute from img
    $matches[2] = preg_replace("/^(.*?)src\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[2]);
    $matches[2] = preg_replace("/\/\s*$/is"," ",$matches[2]);
    $matches[2] = preg_replace("/^(.*?)srcset\s*=\s*[\"\'].*?[\"\']/is","$1",$matches[2]);
    

    $description = '';
    $additionalDescription = '';
    global $wpsc_query;

    if (version_compare(WPSC_VERSION, '3.8', '<')) {
        foreach($wpsc_query->get_products() as $key => $curr_product) {
            if(htmlspecialchars($curr_product['name'], ENT_QUOTES) == $title) {
                $description = $wpsc_query->products[$key]['description'];
                $additionalDescription = $wpsc_query->products[$key]['additional_description'];
                break;
            }
        }
    } else {
        foreach ($wpsc_query->posts as $post) {
            if($post->post_title == $title) {
                $description = $post->post_content;
                $additionalDescription = $post->post_excerpt;
            }
        }
    }

    if (!$cat) { //Product page
        $divWidth = get_option('single_view_image_width');
        $id = '_Main';
    } else { //Category page
        $divWidth = get_option('product_image_width');
    }
    if ($is_main) { //if it is MAIN IMAGE

        if ($cat) $id = $id.md5(rand());
        if (isset($GLOBALS['magictoolbox_main_image_set']) && !$cat) {
            return $matches[0];
        }
        $GLOBALS['magictoolbox_main_image_set'] = true;

        if (preg_match('/wpsc_action=scale_image(\&|\&\#038\;)attachment_id=([0-9]+)/is',$thumb,$thumb_matches)) {
            $touchTheUrl = file_get_contents($thumb); //lets WPEC to resize image
            $attachment_info = wp_get_attachment_image_src( $thumb_matches[2]);
            $thumb = $attachment_info[0];
        }
        //$thumb_name = preg_replace('/^.*?\/([^\/]*?)-[0-9]+x[0-9]+\.(jpg|png|jpeg|gif)/is','$1',$thumb);

        $thumb_name = preg_replace('/'.str_replace('/','\/',site_url('','http')).'(.*)-[0-9]+x[0-9]+(\.(jpg|png|jpeg|gif))/is','$1$2',$thumb);
        if ($thumb_name == $thumb) {//maybe https
      $thumb_name = preg_replace('/'.str_replace('/','\/',site_url('','https')).'(.*)-[0-9]+x[0-9]+(\.(jpg|png|jpeg|gif))/is','$1$2',$thumb);
        }
        if ($thumb_name == $thumb) {
      $thumb_name = preg_replace('/https?:\/\/.*?(\/.*)/ims','$1',$thumb);
        }
        $thumb = WPEcommerce_MagicZoom_get_product_image($thumb_name,'thumb');
        $thumb2x = WPEcommerce_MagicZoom_get_product_image($thumb_name,'thumb2x');
        $img = WPEcommerce_MagicZoom_get_product_image($thumb_name,'original');

        $GLOBALS['magictoolbox']['MagicZoom']['main'] = $plugin->getMainTemplate(compact('img','thumb','thumb2x','id','title','description','additionalDescription','link'));
        if ($cat) {
            $result = $GLOBALS['magictoolbox']['MagicZoom']['main'];
            $result = preg_replace('/<div[^>]*class=\"MagicToolboxMessage\"[^>]*>.*?<\/div>/is','',$result);
        } else {
            $result = 'MAGICTOOLBOX_PLACEHOLDER';
        }

        $oldThumb = $thumb;
        $medium = str_replace('width='.get_option('wpsc_gallery_image_width').'&amp;height='.get_option('wpsc_gallery_image_height'),
                             'width='.get_option('single_view_image_width').'&amp;height='.get_option('single_view_image_height'),$thumb);
        $thumb = str_replace('width='.get_option('single_view_image_width').'&amp;height='.get_option('single_view_image_height'),
                             'width='.get_option('wpsc_gallery_image_width').'&amp;height='.get_option('wpsc_gallery_image_height'),$thumb);
        if (!$plugin->params->checkValue('create-main-image-selector','No')) {

            $GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR'] = $GLOBALS['magictoolbox']['MagicZoom']['selectors'][] = $plugin->getSelectorTemplate(compact('alt','img','medium','medium2x','thumb','thumb2x','id')); //save main image selector to globals
        if ($oldThumb == $thumb ) { //if replaces are not effected
            $GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR'] = str_replace('<img','<img style="height : '.get_option('wpsc_gallery_image_height').'px !important"',$GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR']);
        }
        }

    }
     if ($is_selector && !$is_main && !$cat) { //if image is SELECTOR
        if (isset($title)) { $alt = $title; } else { $alt = ''; }
        if (version_compare(WPSC_VERSION, '3.8.1', '<')) {
            $medium = str_replace('width='.get_option('wpsc_gallery_image_width').'&amp;height='.get_option('wpsc_gallery_image_height'),
                                'width='.get_option('single_view_image_width').'&amp;height='.get_option('single_view_image_height'),$thumb);
        } else {
           if (preg_match('/wpsc_action=scale_image(\&|\&\#038\;)attachment_id=([0-9]+)/is',$thumb,$thumb_matches)) {
                $touchTheUrl = file_get_contents($thumb); //lets WPEC to resize image
                $attachment_info = wp_get_attachment_image_src( $thumb_matches[2]);
                $thumb = $attachment_info[0];
            }
            $medium_name = str_replace(site_url('','http'),'',$thumb);
            if ($medium_name == $thumb) { //maybe https
        $medium_name = str_replace(site_url('','https'),'',$thumb);
            }
            if ($medium_name == $thumb) {
        $medium_name = preg_replace('/https?:\/\/.*?(\/.*)/ims','$1',$thumb);
            }
            $medium_name = preg_replace('/(.*)-[0-9]+x[0-9]+(\.(jpg|png|jpeg|gif))/is','$1$2',$medium_name);
            $medium = WPEcommerce_MagicZoom_get_product_image($medium_name,'thumb');
            if ($plugin->params->checkValue('template','original')) {
                $thumb = WPEcommerce_MagicZoom_get_product_image($medium_name,array(get_option('wpsc_gallery_image_width'),get_option('wpsc_gallery_image_height')));
            } else {
                $thumb = WPEcommerce_MagicZoom_get_product_image($medium_name,'selector');
            }
            $img = WPEcommerce_MagicZoom_get_product_image($medium_name,'original');
        }

        if ($plugin->params->checkValue('template','original')) {
            $result = $plugin->getSelectorTemplate(compact('alt','img','medium','medium2x','thumb','thumb2x','id','title'));
        } else {
            $result = '';
            $GLOBALS['magictoolbox']['MagicZoom']['selectors'][] = $plugin->getSelectorTemplate(compact('alt','img','medium','medium2x','thumb','thumb2x','id','title'));
        }

        if (!isset($GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR_SET'])) {
            $prefix = '{MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR}';
            $GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_MAIN_IMAGE_SELECTOR_SET'] = true;
        }
    }
    $result = preg_replace("/^(.*?)<a(.*?)$/is","$1<a {$matches[1]}$2",$result);
    $result = preg_replace("/^(.*?)<img(.*?)$/is","$1<img {$matches[2]}$2",$result);
    $result = str_replace('class="attachment-gold-thumbnails"','',$result);


    if (empty($prefix)) $prefix = '';
    if (empty($info)) $info = '';
     if ($is_main) {
        $result = $prefix."<div style=\"{$float}\" class=\"MagicToolboxContainer\">{$result}</div>";
        if ($plugin->params->checkValue('keep-selectors-position','No')) {//load selectors under main image
            $result = $result.'{MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS}';
        }
    } else if ($is_selector) {
        $result = $prefix.$result;
         if ($plugin->params->checkValue('keep-selectors-position','No')) {//load selectors under main image
            $GLOBALS['MAGICTOOLBOX_'.strtoupper('magiczoom').'_SELECTORS'][] = $result;
            $result = $matches[0];
        }
    }

    return $result;

}

function WPEcommerce_MagicZoom_get_product_image($title,$size = 'thumb', $image_id = false) {
    $cat = WPEcommerce_MagicZoom_page_check('WPEcommerce');
    $result = $title;


    $post_id = wpsc_the_product_id();

    
    $oldLocale = setlocale(LC_ALL, NULL);
    setlocale(LC_ALL, 'en_US.UTF8');
    
    $plugin = $GLOBALS["magictoolbox"]["WPEcommerceMagicZoom"];
    $useWpImages = $plugin->params->checkValue('use-wordpress-images','yes');
    
    if ($useWpImages ) { 
        
         if (!$image_id) {
            $image_id = get_post_thumbnail_id( $post_id );
        } 
        
        if ($size != 'original') {
            if (!$cat) {
                $thumb = wp_get_attachment_image_src( $image_id, $plugin->params->getValue('single-wordpress-image') );
            } else {
                $thumb = wp_get_attachment_image_src( $image_id, $plugin->params->getValue('category-wordpress-image') );
            }
        } else {
            $thumb = wp_get_attachment_image_src( $image_id, 'full' ); 
        }

        $result = $thumb[0];
        
    } else {

        

        if (!isset($GLOBALS['imagehelper'])) {
            require_once(dirname(__FILE__) . '/core/magictoolbox.imagehelper.class.php');
            $image_dir = 'wp-content/uploads/';
            $url = site_url();
            $shop_dir = ABSPATH;
            $GLOBALS['imagehelper'] = new MagicToolboxImageHelperClass($shop_dir, $image_dir.'magictoolbox_cache', $plugin->params, null, $url);
        }

        $result = $GLOBALS['imagehelper']->create( $title, $size, $post_id);
    }
    setlocale(LC_ALL, $oldLocale);

    return $result;

}

function WPEcommerce_MagicZoom_get_post_attachments($addMain = false)  {

    $post_id = wpsc_the_product_id();

    $attachments = get_children( array(
                                      'post_parent' => $post_id,
                                      'post_status' => 'inherit',
                                      'post_type' => 'attachment',
                                      'post_mime_type' => 'image',
                                      'numberposts' => -1,
                                      'orderby' => 'menu_order',
                                      'order' => 'ASC'
                                  ) );

    if (!count($attachments)) {
    $attachments = wpsc_get_product_gallery($post_id);
    }

    return $attachments;
}


function WPEcommerce_MagicZoom_get_prepared_selectors ($post_id, $useWpImages = false) {

    $attachments = WPEcommerce_MagicZoom_get_post_attachments($useWpImages);


    $post_id = wpsc_the_product_id();
    $id = '_Main';


    
    $selectors = array();
    $oldLocale = setlocale(LC_ALL, NULL);
    setlocale(LC_ALL, 'en_US.UTF8');

    $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];

    if ($useWpImages) { 
    
        foreach ($attachments as $attachment) {

            $img = wp_get_attachment_image_src( $attachment->ID, 'full' ); 
            $img = $img[0];
            
            $medium = wp_get_attachment_image_src( $attachment->ID, $plugin->params->getValue('single-wordpress-image') );
            $medium = $medium[0];
            
            $thumb = wp_get_attachment_image_src( $attachment->ID, $plugin->params->getValue('thumbnails-wordpress-image') ); 
            $thumb = $thumb[0];
            
            $alt = get_post_meta($attachment->ID, '_wp_attachment_image_alt', true);
            $title = $attachment->post_title;
            
            $selectors[] = $plugin->getSelectorTemplate(compact('alt','img','medium','thumb','id','title'));
            
        }
        
    } else {

        require_once(dirname(__FILE__) . '/core/magictoolbox.imagehelper.class.php');
        $url = site_url();
        $shop_dir = ABSPATH;
        $image_dir = 'wp-content/uploads/';
        $imagehelper = new MagicToolboxImageHelperClass($shop_dir, $image_dir.'magictoolbox_cache', $plugin->params, null, $url);

        
        if (isset($GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_MAIN_IMAGE_SELECTOR'])) $selectors[] = $GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_MAIN_IMAGE_SELECTOR'];

        if (isset($GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_MAIN_IMAGE_SELECTOR'])) {
            $test_link = preg_replace('/.*?href=[\'\"](.*?)[\'\"].*/is','$1',$GLOBALS['MAGICTOOLBOX_'.strtoupper('MagicZoom').'_MAIN_IMAGE_SELECTOR']);
            if (count($attachments) == 1) {
            $attachmentsKeys = array_keys($attachments);
            if (basename($attachments[$attachmentsKeys[0]]->guid) == basename($test_link)) return array();
            }
        } else {
            $test_link = false;
        }

        foreach ($attachments as $attachment) {
        if (is_object($attachment)) {
            if (!preg_match('/image/is',$attachment->post_mime_type)) continue;
            $meta = wp_get_attachment_metadata($attachment->ID);
            if ($test_link) {
                if (basename($attachment->guid) == basename($test_link)) continue;
            }
            //$title = $alt = '';
            $title = $attachment->post_title;
            $alt = get_post_meta($attachment->ID, '_wp_attachment_image_alt', true);

            
            $imgpath = str_replace($shop_dir,'/',get_attached_file($attachment->ID));

            $img = $imagehelper->create( $imgpath, 'original', $post_id);//$url.'/'.$image_dir.$meta['file'];
            $medium = $imagehelper->create( $imgpath, array($plugin->params->getValue('thumb-max-width'),$plugin->params->getValue('thumb-max-height')), $post_id);
            $medium2x = $imagehelper->create( $imgpath, array($plugin->params->getValue('thumb-max-width')*2,$plugin->params->getValue('thumb-max-height')*2), $post_id);
            $thumb = $imagehelper->create( $imgpath, array($plugin->params->getValue('selector-max-width'),$plugin->params->getValue('selector-max-height')), $post_id);
            $thumb2x = $imagehelper->create( $imgpath, array($plugin->params->getValue('selector-max-width')*2,$plugin->params->getValue('selector-max-height')*2), $post_id);
            $selectors[] = $plugin->getSelectorTemplate(compact('alt','img','medium','medium2x','thumb','thumb2x','id','title'));
        } else { // thecartpress
            $title = $alt = 'NO TITLE YET';
            $file = preg_replace('/^.*?wp-content\/uploads\//is','',$attachment);
            $img = $imagehelper->create( '/'.$image_dir.$file, 'original', $post_id);
            $medium = $imagehelper->create( '/'.$image_dir.$file, array($plugin->params->getValue('thumb-max-width'),$plugin->params->getValue('thumb-max-height')), $post_id);
            $medium2x = $imagehelper->create( '/'.$image_dir.$file, array($plugin->params->getValue('thumb-max-width')*2,$plugin->params->getValue('thumb-max-height')*2), $post_id);
            $thumb = $imagehelper->create( '/'.$image_dir.$file, array($plugin->params->getValue('selector-max-width'),$plugin->params->getValue('selector-max-height')), $post_id);
            $thumb2x = $imagehelper->create( '/'.$image_dir.$file, array($plugin->params->getValue('selector-max-width')*2,$plugin->params->getValue('selector-max-height')*2), $post_id);
            $selectors[] = $plugin->getSelectorTemplate(compact('alt','img','medium','medium2x','thumb','thumb2x','id','title'));
        }

        }
    }


    setlocale(LC_ALL, $oldLocale);

    return $selectors;
}


function WPEcommerce_MagicZoom_page_check ($moduleName = false) {
    switch (strtolower($moduleName)) {
        case 'wpecommerce' : {
            if (!WPSC_VERSION) return 'error';
            if (WPSC_PRESENTABLE_VERSION == '3.7.6.3' || WPSC_PRESENTABLE_VERSION == '3.7.6.4' || WPSC_PRESENTABLE_VERSION == '3.7.8') {
                if ($GLOBALS["wpsc_title_data"]["product"]) {
                    $cat = false;
                }else {
                    $cat = true;
                }
            } else if (WPSC_VERSION == '3.8') {
                if (isset($GLOBALS['wp_the_query']->query_vars['wpsc-product']) && $GLOBALS['wp_the_query']->query_vars['wpsc-product'] != '') {
                    $cat = false;
                } else {
                    $cat = true;
                }
            } else
            if (version_compare(WPSC_VERSION, '3.8.1', '>=')) {
                    if ( $GLOBALS['wp_the_query']->is_single == '1') { /*isset($GLOBALS['wp_the_query']->is_product) && $GLOBALS['wp_the_query']->is_product == '1'*/
                        $cat = false;
                    } else {
                        $cat = true;
                    }
            } else {
                if (!empty($GLOBALS['wp_query']->query_vars['product_url_name']) && $GLOBALS['wp_query']->query_vars['product_url_name'] != '') {
                    $cat = false;
                } else {
                    $cat = true;
                }
            }
        break;}
        case 'jigoshop' : {
            if (!JIGOSHOP_VERSION) return 'error';
            if (function_exists('is_product') && function_exists('is_product_list')) {

              //if (is_product()) $cat = false; else $cat = true;
              if ($GLOBALS['post']->post_type=='product' || is_product()) $cat = false; else $cat = true;

              if (is_product_list()) $cat = true; else $cat = false;
            } else {
              return 'error';
            }
        break;}
    case 'woocommerce' : {
            if (!WOOCOMMERCE_VERSION) return 'error';
            if (function_exists('is_product') && function_exists('is_product_category')) {
              if (is_product()) { 
                    $cat = false; 
                } else { 
                    //if (isset($GLOBALS['post']->post_content) && preg_match('/\[product_page\s+id=\"\d+\"\]/is',$GLOBALS['post']->post_content) !== false) {
                    if (isset($GLOBALS['post']->post_content) && preg_match('/\[product_page\s+id=\"\d+\"\]/is',$GLOBALS['post']->post_content) != false) {
                        $cat = false; 
                    } else {
                        $cat = true;     
                    }
                }
              //if ($GLOBALS['post']->post_type=='product' || is_product()) $cat = false; else $cat = true;
            } else {
              return 'error';
            }
        break;}
        case 'thecartpress' : {
        global $thecartpress;
            if (!isset($thecartpress->settings)) return 'error';
            if (function_exists('is_single')) {
              if (is_single()) $cat = false; else $cat = true;
            } else {
              return 'error';
            }
        break;}

        default : return 'error';
    }
    return $cat;
}



function WPEcommerceMagicZoom_url ($url,$position) {

    if ('commercial' == get_tool_version_WPEcommerce_MagicZoom()) {
    $utm_source = 'CommercialVerison';
    } else {
    if (magictoolbox_WPEcommerce_MagicZoom_get_data_from_db()) {
        $utm_source = 'CommercialVersion';
    } else {
        $utm_source = 'TrialVersion';
    }
    }

    $utm_medium = 'WPEcommerce';
    $utm_content = preg_replace('/\s+/is','-',trim($position));
    $utm_campaign = 'MagicZoom';

    $link = $url.'?utm_source='.$utm_source.'&utm_medium='.$utm_medium.'&utm_content='.$position.'&utm_campaign='.$utm_campaign;

    return $link;
}

// function WPEcommerceMagicZoom_params_map_check ($profile = 'default', $group, $parameter) {
//     $map = WPEcommerceMagicZoom_getParamsMap();
//     if (isset($map[$profile][$group][$parameter])) return true;
//     return false;
// }
function WPEcommerceMagicZoom_getParamsMap () {
    $map = array(
		'product' => array(
			'General' => array(
				'include-headers',
				'page-status',
				'magicscroll',
			),
			'Positioning and Geometry' => array(
				'zoomWidth',
				'zoomHeight',
				'zoomPosition',
				'zoomDistance',
				'thumb-max-width',
				'thumb-max-height',
				'category-thumb-max-width',
				'category-thumb-max-height',
				'square-images',
			),
			'Multiple images' => array(
				'selectorTrigger',
				'transitionEffect',
				'template',
				'selectors-margin',
				'selector-max-width',
				'selector-max-height',
			),
			'Miscellaneous' => array(
				'lazyZoom',
				'rightClick',
				'cssClass',
				'create-main-image-selector',
				'show-message',
				'message',
				'image-quality',
			),
			'Zoom mode' => array(
				'zoomMode',
				'zoomOn',
				'upscale',
				'smoothing',
				'variableZoom',
				'zoomCaption',
			),
			'Hint' => array(
				'hint',
				'textHoverZoomHint',
				'textClickZoomHint',
			),
			'Mobile' => array(
				'zoomModeForMobile',
				'textHoverZoomHintForMobile',
				'textClickZoomHintForMobile',
			),
			'Scroll' => array(
				'width',
				'height',
				'mode',
				'items',
				'speed',
				'autoplay',
				'loop',
				'step',
				'arrows',
				'pagination',
				'easing',
				'scrollOnWheel',
				'lazy-load',
				'scroll-extra-styles',
				'show-image-title',
			),
			'Use Wordpress images' => array(
				'use-wordpress-images',
				'single-wordpress-image',
				'thumbnails-wordpress-image',
			),
		),
		'category' => array(
			'General' => array(
				'include-headers',
				'page-status',
			),
			'Positioning and Geometry' => array(
				'zoomWidth',
				'zoomHeight',
				'zoomPosition',
				'zoomDistance',
				'thumb-max-width',
				'thumb-max-height',
				'category-thumb-max-width',
				'category-thumb-max-height',
				'square-images',
			),
			'Miscellaneous' => array(
				'lazyZoom',
				'rightClick',
				'cssClass',
				'create-main-image-selector',
				'link-to-product-page',
				'show-message',
				'message',
				'image-quality',
			),
			'Zoom mode' => array(
				'zoomMode',
				'zoomOn',
				'upscale',
				'smoothing',
				'variableZoom',
				'zoomCaption',
			),
			'Hint' => array(
				'hint',
				'textHoverZoomHint',
				'textClickZoomHint',
			),
			'Mobile' => array(
				'zoomModeForMobile',
				'textHoverZoomHintForMobile',
				'textClickZoomHintForMobile',
			),
			'Use Wordpress images' => array(
				'use-wordpress-images',
				'category-wordpress-image',
			),
		),
		'default' => array(
			'Positioning and Geometry' => array(
				'zoomWidth',
				'zoomHeight',
				'zoomPosition',
				'zoomDistance',
				'thumb-max-width',
				'thumb-max-height',
				'category-thumb-max-width',
				'category-thumb-max-height',
				'square-images',
			),
			'Miscellaneous' => array(
				'lazyZoom',
				'rightClick',
				'cssClass',
				'create-main-image-selector',
				'link-to-product-page',
				'show-message',
				'message',
				'imagemagick',
				'image-quality',
			),
			'Zoom mode' => array(
				'zoomMode',
				'zoomOn',
				'upscale',
				'smoothing',
				'variableZoom',
				'zoomCaption',
			),
			'Watermark' => array(
				'watermark',
				'watermark-max-width',
				'watermark-max-height',
				'watermark-opacity',
				'watermark-position',
				'watermark-offset-x',
				'watermark-offset-y',
			),
			'Hint' => array(
				'hint',
				'textHoverZoomHint',
				'textClickZoomHint',
			),
			'Mobile' => array(
				'zoomModeForMobile',
				'textHoverZoomHintForMobile',
				'textClickZoomHintForMobile',
			),
			'Use Wordpress images' => array(
				'use-wordpress-images',
				'category-wordpress-image',
			),
		),
	);
    return $map;
}

function WPEcommerceMagicZoom_getParamsProfiles () {

    $blocks = array(
		'product' => 'Product pages',
		'category' => 'Category pages',
		'default' => 'General',
	);

    return $blocks;
}

function WPEcommerceMagicZoom_welcome_license_do_redirect() {
  // Bail if no activation redirect
    if ( ! get_transient( 'WPEcommerce_MagicZoom_welcome_license_activation_redirect' ) ) {
    return;
  }

  // Delete the redirect transient
  delete_transient( 'WPEcommerce_MagicZoom_welcome_license_activation_redirect' );

  // Bail if activating from network, or bulk
  if ( is_network_admin() || isset( $_GET['activate-multi'] ) ) {
    return;
  }

  // Redirect to bbPress about page
  wp_safe_redirect( add_query_arg( array( 'page' => 'WPEcommerceMagicZoom-license-page' ), admin_url( 'admin.php' ) ) );

}

function WPEcommerceMagicZoom_plugin_path() {

  return untrailingslashit( plugin_dir_path( __FILE__ ) );
 
}
 
function WPEcommerce_MagicZoom_locate_template( $template, $template_name, $template_path ) {
 
  global $woocommerce;
 
  $_template = $template;
 
  if ( ! $template_path ) $template_path = $woocommerce->template_url;
 
  $plugin_path  = WPEcommerceMagicZoom_plugin_path() . '/core/templates/';
  
  $template = locate_template(
 
    array(
 
      $template_path . $template_name,
 
      $template_name
 
    )
 
  );
    $post_id = get_the_id();

    if(function_exists('wpml_get_default_language')){
        $default_language = wpml_get_default_language();
        global $main_id;
        $main_id = icl_object_id($post_id, 'post', true, $default_language);

        if($main_id !== $post_id) $post_id = $main_id;   
    }

    if (preg_match('/single-product\/images\/product-image-[^\.]*\.php/is',$template_name) != false) { //fix for puca theme
        $template_name = '/single-product/product-image.php'; 
    } 
      
    if ( file_exists( $plugin_path . $template_name ) ) {
        $template = $plugin_path . $template_name;
    } else {
        $template = $_template;
    }
  
    if ( ! $template ) {
        $template = $_template;
    }

  return $template;
 
}

function WPEcommerce_MagicZoom_get_containers_data($thumbs = array(), $post_id = false, $useWpImages = false) {

    $mainHTML = '';
    $GLOBALS['defaultContainerId'] = 'zoom';
    $containersData = array(
        'zoom' => '',
        '360' => '',
    );
    $productImagesHTML = array();

    $plugin = $GLOBALS['magictoolbox']['WPEcommerceMagicZoom'];
    
    $main_image = $GLOBALS['magictoolbox']['MagicZoom']['main'];
    $main_image = preg_replace('/(<a.*?class=\".*?)\"/is', "$1" . ' lightbox-added"', $main_image);
    $containersData['zoom'] = $main_image;

    if(isset($thumbs) && !empty($thumbs)){ 
        foreach ($thumbs as $index => $thumb) {
            $thumbs[$index] = str_replace('<a ', '<a data-product-id="'.$post_id.'" data-magic-slide-id="zoom" ', $thumb);
        }
     }

    $sMaxWidth = $sMaxHeight = 0;
    if ($useWpImages) {
        global $_wp_additional_image_sizes;
        $imageSize = $plugin->params->getValue('thumbnails-wordpress-image', 'product');
        if (in_array( $imageSize, array('thumbnail', 'medium', 'medium_large', 'large'))) {
            $sMaxWidth = (int)get_option($imageSize.'_size_w');
            $sMaxHeight = (int)get_option($imageSize.'_size_h');
        } else if (isset( $_wp_additional_image_sizes[$imageSize] ) ) {
            $sMaxWidth = (int)$_wp_additional_image_sizes[$imageSize]['width'];
            $sMaxHeight = (int)$_wp_additional_image_sizes[$imageSize]['height'];
        }
    } else {
        $sMaxWidth = (int)$plugin->params->getValue('selector-max-width', 'product');
        $sMaxHeight = (int)$plugin->params->getValue('selector-max-height', 'product');
    }

    $sizeStyle = '';
    if ((int)$sMaxHeight && (int)$sMaxWidth) {
        $sizeStyle = ' style="max-width: '.$sMaxWidth.'px; max-height: '.$sMaxHeight.'px;" ';
    } 

    //video data
    if (metadata_exists( 'post', $post_id, '_provide_videolinks_field' )){
        $scrollEnabled = $plugin->params->checkValue('magicscroll', 'Yes');
        $productVideos = get_post_meta( $post_id, '_provide_videolinks_field', true );
        
        if (!empty($productVideos) && preg_match('/a\:\d+/is',$productVideos)) {
        
            $productVideos = unserialize($productVideos);
            $videoIndex = 1;
         
            foreach ($productVideos as $videoUrl => $videoData) {
                if($videoData['youtube']) {
                    $dataVideoType = 'youtube';
                    $url = 'https://www.youtube.com/embed/'.$videoData['code'];
                    $containersData['video-'.$videoIndex] = '<iframe src="https://www.youtube.com/embed/'.$videoData['code'].'?enablejsapi=1"';
                } else {
                    $dataVideoType = 'vimeo';
                    $url = 'https://player.vimeo.com/video/'.$videoData['code'];
                    $containersData['video-'.$videoIndex] = '<iframe src="https://player.vimeo.com/video/'.$videoData['code'].'?byline=0&portrait=0"';
                }
                
                $containersData['video-'.$videoIndex] .=' frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen data-product-id="'.$post_id.'" data-video-type="'.$dataVideoType.'"></iframe>';
                
                $videoData['thumb'] = str_replace('http://', 'https://', $videoData['thumb']);
                
                $productImagesHTML[] =
                    '<a data-magic-slide-id="video-'.$videoIndex.'" data-product-id="'.$post_id.'" data-video-type="'.$dataVideoType.'" class="video-selector" href="#" onclick="return false">'.
                    '<span><b></b></span>'.
                    '<img src="'.$videoData['thumb'].'" alt="video"'.($scrollEnabled ? '' : ' style="max-width: '.$sMaxWidth.'px; max-height: '.$sMaxHeight.'px;"').'/>'.
                    '</a>';
                $videoIndex++;
            }
            
        }
    }

    $main_id = 0;
    if(function_exists('wpml_get_default_language')){
        $default_language = wpml_get_default_language();
        global $main_id;
        $main_id = icl_object_id($post_id, 'post', true, $default_language);
    }


    if ((metadata_exists( 'post', $post_id, '_magic360_data' ) || metadata_exists( 'post', $main_id, '_magic360_data' )) && magictoolbox_WPEcommerce_MagicZoom_check_plugin_active('magic360') ){

        $magic360_plugin = $GLOBALS['magictoolbox']['WooCommerceMagic360'];
        $magic360_plugin->params->setProfile('product');

        if(!empty($magic360_plugin) && $magic360_plugin->params->checkValue('page-status','Yes') ){

            $magic360_data = json_decode((get_post_meta( $post_id, '_magic360_data', true )), true);

            if(function_exists('wpml_get_default_language')){
                $default_language = wpml_get_default_language();
                global $main_id;
                $main_id = icl_object_id($post_id, 'post', true, $default_language);
                $magic360_data = json_decode((get_post_meta( $main_id, '_magic360_data', true )), true);
            }


            $magic360_image_gallery = Array();
            if(!empty($magic360_data) && array_key_exists('images_ids', $magic360_data)) $magic360_image_gallery = $magic360_data['images_ids'];

            if(!empty($magic360_image_gallery)){

                $watermark = $plugin->params->getValue('watermark');
                $plugin->params->setValue('watermark', '');

                $magic360_selector_path = $magic360_plugin->params->getValue('selector-path');
                
                if (!$useWpImages) {
                    $magic360_selector = '<a data-product-id="'.$post_id.'" data-magic-slide-id="360" style="display:inline-block;" class="m360-selector" title="360" href="#" onclick="return false;"><img src="'.WPEcommerce_MagicZoom_get_product_image('/'.ltrim($magic360_selector_path,'/'),'selector').'" alt="360" /></a>';
                } else {
                    //$magic360_selector = '<a data-product-id="'.$post_id.'" data-magic-slide-id="360" style="display:inline-block;" class="m360-selector" title="360" href="#" onclick="return false;"><img style="max-width: '.$sMaxWidth.'px; max-height: '.$sMaxHeight.'px;" src="'.get_site_url().$magic360_selector_path.'" alt="360" /></a>';
                    $magic360_selector = '<a data-product-id="'.$post_id.'" data-magic-slide-id="360" style="display:inline-block;" class="m360-selector" title="360" href="#" onclick="return false;"><img '.$sizeStyle.' src="'.get_site_url().'/'.ltrim($magic360_selector_path,'/').'" alt="360" /></a>';
                }     
                
                $plugin->params->setValue('watermark', $watermark);
                array_unshift($thumbs, $magic360_selector);

                foreach($magic360_image_gallery as $i => $image_id) {
                    $image_src = wp_get_attachment_image_src($image_id, 'original', $image_id);
                    $image_src = preg_replace('/.*(\/wp-content.*)/','$1', $image_src[0]);
                    $GLOBALS['magic360images'][$i] = array(
                        'medium' => WooCommerce_Magic360_get_product_image($image_src,'thumb', $image_id),
                        'img' => WooCommerce_Magic360_get_product_image($image_src,'original', $image_id)
                    );
                }

                $magic360_plugin->params->setValue('columns', $magic360_data['options']['columns']);

                usort($GLOBALS['magic360images'], 'magictoolbox_WPEcommerce_MagicZoom_key_sort');

                $containersData['360'] = $magic360_plugin->getMainTemplate($GLOBALS['magic360images']);
                
                $defaultView = $magic360_plugin->params->getValue('default-spin-view');
                if ($defaultView == 'Spin') {
                    $GLOBALS['defaultContainerId'] = '360';
                } else {
                    $GLOBALS['defaultContainerId'] = 'zoom';
                }

                global $magictoolbox_Magic360_page_has_tool;
                $magictoolbox_Magic360_page_has_tool = true;
                unset($GLOBALS['magic360images']);
            }
        }

    }
    
    return array('containersData'       => $containersData,
                 'productImagesHTML'    => $productImagesHTML,
                 'thumbs'               => $thumbs);
    
}


if( function_exists('register_block_type' ) ){
  if( !function_exists('WPEcommerce_MagicZoom_addmedia_block')){
    function WPEcommerce_MagicZoom_addmedia_block(){

      wp_register_script(
        'wpecommerce-magiczoom-addmedia-block-editor-js',
        plugins_url('/gutenberg/addmedia-block/editor-script.js', __FILE__),
        array( 'wp-blocks', 'wp-element', 'wp-editor', 'jquery'), NULL
      );

      register_block_type( 'wpecommerce-magiczoom/addmedia-block', array(
          'editor_script' => 'wpecommerce-magiczoom-addmedia-block-editor-js',
      ) );
    }

    add_action( 'init', 'WPEcommerce_MagicZoom_addmedia_block' );
  }

}

function WPEcommerce_MagicZoom_slideshow_gallery($atts){

    global $wpdb;

    $table_name = $wpdb->prefix . strtolower('MagicZoom_store');
    $result = $wpdb->get_results("SELECT id,name FROM $table_name ");

    return rest_ensure_response( $result );
}

add_action( 'rest_api_init', 'WPEcommerce_MagicZoom_gallery_route');

function WPEcommerce_MagicZoom_gallery_route() {
            
    register_rest_route( 'MagicZoom', 'get-shortcodes', array(
            'methods' => 'GET',
            'callback' => 'WPEcommerce_MagicZoom_slideshow_gallery',
            'permission_callback' => function() {
                return current_user_can( 'edit_posts' );
            }, 
    ));
}

?>